#IFNDEF __FB_UNIX__
  '#DEFINE dSINGLE
  #LIBPATH "C:\opt\Gtk\lib"
#ELSE
  #DEFINE dDOUBLE
#ENDIF

' you may use further libraries (optional)
#INCLUDE ONCE "ode/ode.bi"
' this header must be included
#INCLUDE ONCE "../Sim_Player.bi"

' define your variables here
'STATIC SHARED AS dReal ...
'STATIC SHARED AS GLfloat ...

' stuff to start the simulation
SUB new_sim CDECL(BYREF Ti AS guint32) STATIC
  ' create your scene here, set initial OpenGl parameters
END SUB

' stuff to end the simulation (optional)
SUB del_sim CDECL(BYREF Ti AS guint32) STATIC
  ' delete your structures here and free used memory
END SUB

' stuff for GtkWidget::expose_event from OpenGL drawing area
SUB expose CDECL() STATIC
  ' draw your scene here
END SUB

' stuff for simulation loop
SUB time_out CDECL() STATIC
  ' calculate your scene here (no drawing)
END SUB

' stuff to react on keypress (optional)
FUNCTION keyboard CDECL(BYVAL Ev AS GdkEventKey PTR) AS gboolean STATIC
  ' handle Ev here, return TRUE to stop further handling (or FALSE)
  RETURN FALSE
END FUNCTION

' stuff for setting parameters (optional)
SUB parameters CDECL(BYVAL Wid AS GtkWindow PTR) STATIC
  gtk_window_set_transient_for(GTK_WINDOW(YOUR_WINDOW_HERE), Wid)
  gtk_window_set_destroy_with_parent(GTK_WINDOW(YOUR_WINDOW_HERE), TRUE)
  ' open a GTK window, handle user input
END SUB

' stuff to report for Sim_Player
SUB sim_init CDECL ALIAS "sim_init"(BYVAL I AS _Interface PTR) STATIC EXPORT

  I->new_sim = @new_sim()
  I->del_sim = @del_sim() ' or NULL
  I->expos = @expose()
  I->keybo = @keyboard() ' or NULL
  I->param = @parameters() ' or NULL
  I->tiout = @time_out()
  I->descr = "Your description here"

END SUB

